Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 3863)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 3864)
@@ -474,10 +652,9 @@
        MODULE PROCEDURE salsa_boundary_conds_decycle
     END INTERFACE salsa_boundary_conds
-!    
+!
 !-- Data output checks for 2D/3D data to be done in check_parameters
     INTERFACE salsa_check_data_output
        MODULE PROCEDURE salsa_check_data_output
     END INTERFACE salsa_check_data_output
-    
 !
 !-- Input parameter checks to be done in check_parameters
@@ -485,5 +662,4 @@
        MODULE PROCEDURE salsa_check_parameters
     END INTERFACE salsa_check_parameters
-
 !
 !-- Averaging of 3D data for output
@@ -491,5 +667,4 @@
        MODULE PROCEDURE salsa_3d_data_averaging
     END INTERFACE salsa_3d_data_averaging
-
 !
 !-- Data output of 2D quantities
@@ -497,5 +672,4 @@
        MODULE PROCEDURE salsa_data_output_2d
     END INTERFACE salsa_data_output_2d
-
 !
 !-- Data output of 3D data
@@ -503,5 +677,4 @@
        MODULE PROCEDURE salsa_data_output_3d
     END INTERFACE salsa_data_output_3d
-    
 !
 !-- Data output of 3D data
@@ -509,5 +682,4 @@
        MODULE PROCEDURE salsa_data_output_mask
     END INTERFACE salsa_data_output_mask
-
 !
 !-- Definition of data output quantities
@@ -515,5 +687,4 @@
        MODULE PROCEDURE salsa_define_netcdf_grid
     END INTERFACE salsa_define_netcdf_grid
-    
 !
 !-- Output of information to the header file
@@ -521,11 +692,9 @@
        MODULE PROCEDURE salsa_header
     END INTERFACE salsa_header
-  
-!
-!-- Initialization actions  
+!
+!-- Initialization actions
     INTERFACE salsa_init
        MODULE PROCEDURE salsa_init
     END INTERFACE salsa_init
- 
 !
 !-- Initialization of arrays
@@ -533,5 +702,4 @@
        MODULE PROCEDURE salsa_init_arrays
     END INTERFACE salsa_init_arrays
-
 !
 !-- Writing of binary output for restart runs  !!! renaming?!
@@ -539,5 +707,4 @@
        MODULE PROCEDURE salsa_wrd_local
     END INTERFACE salsa_wrd_local
-    
 !
 !-- Reading of NAMELIST parameters
@@ -545,5 +712,4 @@
        MODULE PROCEDURE salsa_parin
     END INTERFACE salsa_parin
-
 !
 !-- Reading of parameters for restart runs
@@ -551,5 +717,4 @@
        MODULE PROCEDURE salsa_rrd_local
     END INTERFACE salsa_rrd_local
-    
 !
 !-- Swapping of time levels (required for prognostic variables)
@@ -557,38 +722,43 @@
        MODULE PROCEDURE salsa_swap_timelevel
     END INTERFACE salsa_swap_timelevel
-
+!
+!-- Interface between PALM and salsa
     INTERFACE salsa_driver
        MODULE PROCEDURE salsa_driver
     END INTERFACE salsa_driver
-
+!
+!-- Prognostics equations for salsa variables
+    INTERFACE salsa_prognostic_equations
+       MODULE PROCEDURE salsa_prognostic_equations
+       MODULE PROCEDURE salsa_prognostic_equations_ij
+    END INTERFACE salsa_prognostic_equations
+!
+!-- Tendency salsa variables
     INTERFACE salsa_tendency
        MODULE PROCEDURE salsa_tendency
        MODULE PROCEDURE salsa_tendency_ij
     END INTERFACE salsa_tendency
-    
-    
-    
+
+
     SAVE
 
     PRIVATE
 !
-!-- Public functions: 
-    PUBLIC salsa_boundary_conds, salsa_check_data_output,                      &
-           salsa_check_parameters, salsa_3d_data_averaging,                    &
-           salsa_data_output_2d, salsa_data_output_3d, salsa_data_output_mask, &
-           salsa_define_netcdf_grid, salsa_diagnostics, salsa_driver,          &
-           salsa_header, salsa_init, salsa_init_arrays, salsa_parin,           &
-           salsa_rrd_local, salsa_swap_timelevel, salsa_tendency,              &
-           salsa_wrd_local
+!-- Public functions:
+    PUBLIC salsa_boundary_conds, salsa_check_data_output, salsa_check_parameters,                  &
+           salsa_3d_data_averaging, salsa_data_output_2d, salsa_data_output_3d,                    &
+           salsa_data_output_mask, salsa_define_netcdf_grid, salsa_diagnostics, salsa_driver,      &
+           salsa_emission_update, salsa_header, salsa_init, salsa_init_arrays, salsa_parin,        &
+           salsa_rrd_local, salsa_swap_timelevel, salsa_prognostic_equations, salsa_wrd_local
 !
 !-- Public parameters, constants and initial values
-    PUBLIC dots_salsa, dt_salsa, last_salsa_time, lsdepo, salsa,               &
-           salsa_gases_from_chem, skip_time_do_salsa
+    PUBLIC bc_am_t_val, bc_an_t_val, bc_gt_t_val, dots_salsa, dt_salsa,                            &
+           ibc_salsa_b, last_salsa_time, lsdepo, nest_salsa, salsa, salsa_gases_from_chem,         &
+           skip_time_do_salsa
 !
 !-- Public prognostic variables
-    PUBLIC aerosol_mass, aerosol_number, fn2a, fn2b, gconc_2, in1a, in2b,      &
-           mconc_2, nbins, ncc, ncc_tot, nclim, nconc_2, ngast, prtcl, Ra_dry, &
-           salsa_gas, sedim_vd
-           
+    PUBLIC aerosol_mass, aerosol_number, gconc_2, mconc_2, nbins_aerosol, ncc, ncomponents_mass,   &
+           nclim, nconc_2, ngases_salsa, prtcl, ra_dry, salsa_gas, sedim_vd
+
 
  CONTAINS
@@ -603,102 +773,21 @@
     IMPLICIT NONE
 
-    CHARACTER (LEN=80) ::  line   !< dummy string that contains the current line
-                                  !< of the parameter file 
-                                  
-    NAMELIST /salsa_parameters/             &
-                          advect_particle_water, & ! Switch for advecting 
-                                                ! particle water. If .FALSE., 
-                                                ! equilibration is called at 
-                                                ! each time step.       
-                          bc_salsa_b,       &   ! bottom boundary condition
-                          bc_salsa_t,       &   ! top boundary condition
-                          decycle_lr,       &   ! decycle SALSA components
-                          decycle_method,   &   ! decycle method applied: 
-                                                ! 1=left 2=right 3=south 4=north
-                          decycle_ns,       &   ! decycle SALSA components
-                          depo_vege_type,   &   ! Parametrisation type
-                          depo_topo_type,   &   ! Parametrisation type
-                          dpg,              &   ! Mean diameter for the initial 
-                                                ! log-normal modes
-                          dt_salsa,         &   ! SALSA timestep in seconds
-                          feedback_to_palm, &   ! allow feedback due to
-                                                ! hydration / condensation
-                          H2SO4_init,       &   ! Init value for sulphuric acid
-                          HNO3_init,        &   ! Init value for nitric acid
-                          igctyp,           &   ! Initial gas concentration type 
-                          isdtyp,           &   ! Initial size distribution type                                                
-                          listspec,         &   ! List of actived aerosols 
-                                                ! (string list)
-                          mass_fracs_a,     &   ! Initial relative contribution  
-                                                ! of each species to particle  
-                                                ! volume in a-bins, 0 for unused 
-                          mass_fracs_b,     &   ! Initial relative contribution  
-                                                ! of each species to particle 
-                                                ! volume in b-bins, 0 for unused
-                          n_lognorm,        &   ! Number concentration for the 
-                                                ! log-normal modes                                                
-                          nbin,             &   ! Number of size bins for 
-                                                ! aerosol size subranges 1 & 2
-                          nf2a,             &   ! Number fraction of particles 
-                                                ! allocated to a-bins in 
-                                                ! subrange 2 b-bins will get 
-                                                ! 1-nf2a                          
-                          NH3_init,         &   ! Init value for ammonia 
-                          nj3,              &   ! J3 parametrization
-                                                ! 1 = condensational sink 
-                                                !     (Kerminen&Kulmala, 2002)
-                                                ! 2 = coagulational sink 
-                                                !     (Lehtinen et al. 2007)
-                                                ! 3 = coagS+self-coagulation 
-                                                !     (Anttila et al. 2010)                                                   
-                          nlcnd,            &   ! Condensation master switch
-                          nlcndgas,         &   ! Condensation of gases
-                          nlcndh2oae,       &   ! Condensation of H2O                           
-                          nlcoag,           &   ! Coagulation master switch
-                          nldepo,           &   ! Deposition master switch
-                          nldepo_vege,      &   ! Deposition on vegetation 
-                                                ! master switch
-                          nldepo_topo,      &   ! Deposition on topo master
-                                                ! switch                          
-                          nldistupdate,     &   ! Size distribution update
-                                                ! master switch
-                          nsnucl,           &   ! Nucleation scheme: 
-                                                ! 0 = off,
-                                                ! 1 = binary nucleation
-                                                ! 2 = activation type nucleation
-                                                ! 3 = kinetic nucleation
-                                                ! 4 = ternary nucleation
-                                                ! 5 = nucleation with organics
-                                                ! 6 = activation type of 
-                                                !     nucleation with H2SO4+ORG
-                                                ! 7 = heteromolecular nucleation 
-                                                !     with H2SO4*ORG
-                                                ! 8 = homomolecular nucleation  
-                                                !     of H2SO4 + heteromolecular 
-                                                !     nucleation with H2SO4*ORG
-                                                ! 9 = homomolecular nucleation 
-                                                !     of H2SO4 and ORG + hetero-
-                                                !     molecular nucleation with 
-                                                !     H2SO4*ORG
-                          OCNV_init,        &   ! Init value for non-volatile 
-                                                ! organic gases
-                          OCSV_init,        &   ! Init value for semi-volatile 
-                                                ! organic gases
-                          read_restart_data_salsa, & ! read restart data for 
-                                                     ! salsa
-                          reglim,           &   ! Min&max diameter limits of 
-                                                ! size subranges
-                          salsa,            &   ! Master switch for SALSA
-                          salsa_source_mode,&   ! 'read_from_file' or 'constant' 
-                                                ! or 'no_source'
-                          sigmag,           &   ! stdev for the initial log-
-                                                ! normal modes                                                
-                          skip_time_do_salsa, & ! Starting time of SALSA (s)
-                          van_der_waals_coagc,& ! include van der Waals forces
-                          write_binary_salsa    ! Write binary for salsa
-                           
-       
+    CHARACTER(LEN=80) ::  line   !< dummy string that contains the current line
+                                  !< of the parameter file
+
+    NAMELIST /salsa_parameters/      aerosol_flux_dpg, aerosol_flux_mass_fracs_a,                  &
+                                     aerosol_flux_mass_fracs_b, aerosol_flux_sigmag,               &
+                                     advect_particle_water, bc_salsa_b, bc_salsa_t, decycle_lr,    &
+                                     decycle_method, decycle_ns, depo_pcm_par, depo_pcm_type,      &
+                                     depo_surf_par, dpg, dt_salsa, feedback_to_palm, h2so4_init,   &
+                                     hno3_init, igctyp, isdtyp, listspec, mass_fracs_a,            &
+                                     mass_fracs_b, n_lognorm, nbin, nest_salsa, nf2a, nh3_init,    &
+                                     nj3, nlcnd, nlcndgas, nlcndh2oae, nlcoag, nldepo, nldepo_pcm, &
+                                     nldepo_surf, nldistupdate, nsnucl, ocnv_init, ocsv_init,      &
+                                     read_restart_data_salsa, reglim, salsa, salsa_emission_mode,  &
+                                     sigmag, skip_time_do_salsa, surface_aerosol_flux,             &
+                                     van_der_waals_coagc, write_binary_salsa
+
     line = ' '
-       
 !
 !-- Try to find salsa package
@@ -709,9 +798,7 @@
     ENDDO
     BACKSPACE ( 11 )
-
 !
 !-- Read user-defined namelist
     READ ( 11, salsa_parameters )
-
 !
 !-- Enable salsa (salsa switch in modules.f90)
@@ -719,8 +806,7 @@
 
  10 CONTINUE
-       
+
  END SUBROUTINE salsa_parin
 
- 
 !------------------------------------------------------------------------------!
 ! Description:
@@ -730,17 +816,16 @@
  SUBROUTINE salsa_check_parameters
 
-    USE control_parameters,                                                    &
+    USE control_parameters,                                                                        &
         ONLY:  message_string
-       
+
     IMPLICIT NONE
-    
+
 !
 !-- Checks go here (cf. check_parameters.f90).
     IF ( salsa  .AND.  .NOT.  humidity )  THEN
-       WRITE( message_string, * ) 'salsa = ', salsa, ' is ',                   &
-              'not allowed with humidity = ', humidity
-       CALL message( 'check_parameters', 'SA0009', 1, 2, 0, 6, 0 )
+       WRITE( message_string, * ) 'salsa = ', salsa, ' is not allowed with humidity = ', humidity
+       CALL message( 'salsa_check_parameters', 'PA0594', 1, 2, 0, 6, 0 )
     ENDIF
-    
+
     IF ( bc_salsa_b == 'dirichlet' )  THEN
        ibc_salsa_b = 0
@@ -748,24 +833,29 @@
        ibc_salsa_b = 1
     ELSE
-       message_string = 'unknown boundary condition: bc_salsa_b = "'           &
-                         // TRIM( bc_salsa_t ) // '"'
-       CALL message( 'check_parameters', 'SA0011', 1, 2, 0, 6, 0 )                  
+       message_string = 'unknown boundary condition: bc_salsa_b = "' // TRIM( bc_salsa_t ) // '"'
+       CALL message( 'salsa_check_parameters', 'PA0595', 1, 2, 0, 6, 0 )
     ENDIF
-    
+
     IF ( bc_salsa_t == 'dirichlet' )  THEN
        ibc_salsa_t = 0
     ELSEIF ( bc_salsa_t == 'neumann' )  THEN
        ibc_salsa_t = 1
+    ELSEIF ( bc_salsa_t == 'nested' )  THEN
+       ibc_salsa_t = 2
     ELSE
-       message_string = 'unknown boundary condition: bc_salsa_t = "'           &
-                         // TRIM( bc_salsa_t ) // '"'
-       CALL message( 'check_parameters', 'SA0012', 1, 2, 0, 6, 0 )                  
+       message_string = 'unknown boundary condition: bc_salsa_t = "' // TRIM( bc_salsa_t ) // '"'
+       CALL message( 'salsa_check_parameters', 'PA0596', 1, 2, 0, 6, 0 )
     ENDIF
-    
+
     IF ( nj3 < 1  .OR.  nj3 > 3 )  THEN
        message_string = 'unknown nj3 (must be 1-3)'
-       CALL message( 'check_parameters', 'SA0044', 1, 2, 0, 6, 0 )
+       CALL message( 'salsa_check_parameters', 'PA0597', 1, 2, 0, 6, 0 )
     ENDIF
-           
+
+    IF ( salsa_emission_mode == 'read_from_file'  .AND.  ibc_salsa_b  == 0 ) THEN
+       message_string = 'salsa_emission_mode == read_from_file requires bc_salsa_b = "Neumann"'
+       CALL message( 'salsa_check_parameters','PA0598', 1, 2, 0, 6, 0 )
+    ENDIF
+
  END SUBROUTINE salsa_check_parameters
 
@@ -775,18 +865,18 @@
 ! ------------
 !> Subroutine defining appropriate grid for netcdf variables.
-!> It is called out from subroutine netcdf. 
+!> It is called out from subroutine netcdf.
 !> Same grid as for other scalars (see netcdf_interface_mod.f90)
 !------------------------------------------------------------------------------!
  SUBROUTINE salsa_define_netcdf_grid( var, found, grid_x, grid_y, grid_z )
-    
+
     IMPLICIT NONE
 
-    CHARACTER (LEN=*), INTENT(OUT) ::  grid_x   !< 
-    CHARACTER (LEN=*), INTENT(OUT) ::  grid_y   !< 
-    CHARACTER (LEN=*), INTENT(OUT) ::  grid_z   !< 
-    CHARACTER (LEN=*), INTENT(IN)  ::  var      !<
-    
+    CHARACTER(LEN=*), INTENT(OUT) ::  grid_x   !<
+    CHARACTER(LEN=*), INTENT(OUT) ::  grid_y   !<
+    CHARACTER(LEN=*), INTENT(OUT) ::  grid_z   !<
+    CHARACTER(LEN=*), INTENT(IN)  ::  var      !<
+
     LOGICAL, INTENT(OUT) ::  found   !<
-    
+
     found  = .TRUE.
 !
@@ -794,30 +884,30 @@
 
     IF ( var(1:2) == 'g_' )  THEN
-       grid_x = 'x' 
-       grid_y = 'y' 
-       grid_z = 'zu'    
+       grid_x = 'x'
+       grid_y = 'y'
+       grid_z = 'zu'
     ELSEIF ( var(1:4) == 'LDSA' )  THEN
-       grid_x = 'x' 
-       grid_y = 'y' 
+       grid_x = 'x'
+       grid_y = 'y'
        grid_z = 'zu'
     ELSEIF ( var(1:5) == 'm_bin' )  THEN
-       grid_x = 'x' 
-       grid_y = 'y' 
+       grid_x = 'x'
+       grid_y = 'y'
        grid_z = 'zu'
     ELSEIF ( var(1:5) == 'N_bin' )  THEN
-       grid_x = 'x' 
-       grid_y = 'y' 
+       grid_x = 'x'
+       grid_y = 'y'
        grid_z = 'zu'
     ELSEIF ( var(1:4) == 'Ntot' ) THEN
-       grid_x = 'x' 
-       grid_y = 'y' 
+       grid_x = 'x'
+       grid_y = 'y'
        grid_z = 'zu'
     ELSEIF ( var(1:2) == 'PM' )  THEN
-       grid_x = 'x' 
-       grid_y = 'y' 
+       grid_x = 'x'
+       grid_y = 'y'
        grid_z = 'zu'
     ELSEIF ( var(1:2) == 's_' )  THEN
-       grid_x = 'x' 
-       grid_y = 'y' 
+       grid_x = 'x'
+       grid_y = 'y'
        grid_z = 'zu'
     ELSE
@@ -830,5 +920,4 @@
  END SUBROUTINE salsa_define_netcdf_grid
 
- 
 !------------------------------------------------------------------------------!
 ! Description:
@@ -846,87 +935,87 @@
     WRITE( io, 2 ) skip_time_do_salsa
     WRITE( io, 3 ) dt_salsa
-    WRITE( io, 12 )  SHAPE( aerosol_number(1)%conc ), nbins
+    WRITE( io, 4 )  SHAPE( aerosol_number(1)%conc ), nbins_aerosol
     IF ( advect_particle_water )  THEN
-       WRITE( io, 16 )  SHAPE( aerosol_mass(1)%conc ), ncc_tot*nbins,          &
+       WRITE( io, 5 )  SHAPE( aerosol_mass(1)%conc ), ncomponents_mass*nbins_aerosol,             &
                         advect_particle_water
     ELSE
-       WRITE( io, 16 )  SHAPE( aerosol_mass(1)%conc ), ncc*nbins,              &
-                        advect_particle_water
+       WRITE( io, 5 )  SHAPE( aerosol_mass(1)%conc ), ncc*nbins_aerosol, advect_particle_water
     ENDIF
     IF ( .NOT. salsa_gases_from_chem )  THEN
-       WRITE( io, 17 )  SHAPE( aerosol_mass(1)%conc ), ngast,                  &
-                        salsa_gases_from_chem
+       WRITE( io, 6 )  SHAPE( aerosol_mass(1)%conc ), ngases_salsa, salsa_gases_from_chem
     ENDIF
-    WRITE( io, 4 ) 
+    WRITE( io, 7 )
     IF ( nsnucl > 0 )  THEN
-       WRITE( io, 5 ) nsnucl, nj3
+       WRITE( io, 8 ) nsnucl, nj3
     ENDIF
     IF ( nlcoag )  THEN
-       WRITE( io, 6 ) 
+       WRITE( io, 9 )
     ENDIF
     IF ( nlcnd )  THEN
-       WRITE( io, 7 ) nlcndgas, nlcndh2oae
+       WRITE( io, 10 ) nlcndgas, nlcndh2oae
+    ENDIF
+    IF ( lspartition )  THEN
+       WRITE( io, 11 )
     ENDIF
     IF ( nldepo )  THEN
-       WRITE( io, 14 ) nldepo_vege, nldepo_topo
+       WRITE( io, 12 ) nldepo_pcm, nldepo_surf
     ENDIF
-    WRITE( io, 8 )  reglim, nbin, bin_low_limits
-    WRITE( io, 15 ) nsect
-    WRITE( io, 13 ) ncc, listspec, mass_fracs_a, mass_fracs_b
+    WRITE( io, 13 )  reglim, nbin, bin_low_limits
+    IF ( isdtyp == 0 )  WRITE( io, 14 ) nsect
+    WRITE( io, 15 ) ncc, listspec, mass_fracs_a, mass_fracs_b
     IF ( .NOT. salsa_gases_from_chem )  THEN
-       WRITE( io, 18 ) ngast, H2SO4_init, HNO3_init, NH3_init, OCNV_init,      &
-                       OCSV_init
+       WRITE( io, 16 ) ngases_salsa, h2so4_init, hno3_init, nh3_init, ocnv_init, ocsv_init
     ENDIF
-    WRITE( io, 9 )  isdtyp, igctyp
+    WRITE( io, 17 )  isdtyp, igctyp
     IF ( isdtyp == 0 )  THEN
-       WRITE( io, 10 )  dpg, sigmag, n_lognorm
+       WRITE( io, 18 )  dpg, sigmag, n_lognorm
     ELSE
-       WRITE( io, 11 )
+       WRITE( io, 19 )
     ENDIF
-    
-
-1   FORMAT (//' SALSA information:'/                                           &
+    IF ( nest_salsa )  WRITE( io, 20 )  nest_salsa
+    WRITE( io, 21 ) salsa_emission_mode
+
+
+1   FORMAT (//' SALSA information:'/                                                               &
               ' ------------------------------'/)
 2   FORMAT   ('    Starts at: skip_time_do_salsa = ', F10.2, '  s')
 3   FORMAT  (/'    Timestep: dt_salsa = ', F6.2, '  s')
-12  FORMAT  (/'    Array shape (z,y,x,bins):'/                                 &
+4   FORMAT  (/'    Array shape (z,y,x,bins):'/                                                     &
               '       aerosol_number:  ', 4(I3)) 
-16  FORMAT  (/'       aerosol_mass:    ', 4(I3),/                              &
+5   FORMAT  (/'       aerosol_mass:    ', 4(I3),/                                                  &
               '       (advect_particle_water = ', L1, ')')
-17  FORMAT   ('       salsa_gas: ', 4(I3),/                                    &
+6   FORMAT   ('       salsa_gas: ', 4(I3),/                                                        &
               '       (salsa_gases_from_chem = ', L1, ')')
-4   FORMAT  (/'    Aerosol dynamic processes included: ')
-5   FORMAT  (/'       nucleation (scheme = ', I1, ' and J3 parametrization = ',&
-               I1, ')')
-6   FORMAT  (/'       coagulation')
-7   FORMAT  (/'       condensation (of precursor gases = ', L1,                &
-              '          and water vapour = ', L1, ')' )
-14  FORMAT  (/'       dry deposition (on vegetation = ', L1,                   &
-              '          and on topography = ', L1, ')')              
-8   FORMAT  (/'    Aerosol bin subrange limits (in metres): ',  3(ES10.2E3), / &
-              '    Number of size bins for each aerosol subrange: ', 2I3,/     &
+7   FORMAT  (/'    Aerosol dynamic processes included: ')
+8   FORMAT  (/'       nucleation (scheme = ', I1, ' and J3 parametrization = ', I1, ')')
+9   FORMAT  (/'       coagulation')
+10  FORMAT  (/'       condensation (of precursor gases = ', L1, ' and water vapour = ', L1, ')' )
+11  FORMAT  (/'       dissolutional growth by HNO3 and NH3')
+12  FORMAT  (/'       dry deposition (on vegetation = ', L1, ' and on topography = ', L1, ')')
+13  FORMAT  (/'    Aerosol bin subrange limits (in metres): ',  3(ES10.2E3), /                     &
+              '    Number of size bins for each aerosol subrange: ', 2I3,/                         &
               '    Aerosol bin limits (in metres): ', 9(ES10.2E3))
-15  FORMAT   ('    Initial number concentration in bins at the lowest level',  &
-              ' (#/m**3):', 9(ES10.2E3))        
-13  FORMAT  (/'    Number of chemical components used: ', I1,/                 &
-              '       Species: ',7(A6),/                                       &
-              '    Initial relative contribution of each species to particle', & 
-              ' volume in:',/                                                  &
-              '       a-bins: ', 7(F6.3),/                                     &
+14  FORMAT   ('    Initial number concentration in bins at the lowest level (#/m**3):', 9(ES10.2E3))
+15  FORMAT  (/'    Number of chemical components used: ', I1,/                                     &
+              '       Species: ',7(A6),/                                                           &
+              '    Initial relative contribution of each species to particle volume in:',/         &
+              '       a-bins: ', 7(F6.3),/                                                         &
               '       b-bins: ', 7(F6.3))
-18  FORMAT  (/'    Number of gaseous tracers used: ', I1,/                     &
-              '    Initial gas concentrations:',/                              &
-              '       H2SO4: ',ES12.4E3, ' #/m**3',/                           &
-              '       HNO3:  ',ES12.4E3, ' #/m**3',/                           &
-              '       NH3:   ',ES12.4E3, ' #/m**3',/                           &
-              '       OCNV:  ',ES12.4E3, ' #/m**3',/                           &
+16  FORMAT  (/'    Number of gaseous tracers used: ', I1,/                                         &
+              '    Initial gas concentrations:',/                                                  &
+              '       H2SO4: ',ES12.4E3, ' #/m**3',/                                               &
+              '       HNO3:  ',ES12.4E3, ' #/m**3',/                                               &
+              '       NH3:   ',ES12.4E3, ' #/m**3',/                                               &
+              '       OCNV:  ',ES12.4E3, ' #/m**3',/                                               &
               '       OCSV:  ',ES12.4E3, ' #/m**3')
-9    FORMAT (/'   Initialising concentrations: ', /                            &
-              '      Aerosol size distribution: isdtyp = ', I1,/               &
+17   FORMAT (/'   Initialising concentrations: ', /                                                &
+              '      Aerosol size distribution: isdtyp = ', I1,/                                   &
               '      Gas concentrations: igctyp = ', I1 )
-10   FORMAT ( '      Mode diametres: dpg(nmod) = ', 7(F7.3),/                  &
-              '      Standard deviation: sigmag(nmod) = ', 7(F7.2),/           &
-              '      Number concentration: n_lognorm(nmod) = ', 7(ES12.4E3) )
-11   FORMAT (/'      Size distribution read from a file.')
+18   FORMAT ( '      Mode diametres: dpg(nmod) = ', 7(F7.3), ' (m)', /                             &
+              '      Standard deviation: sigmag(nmod) = ', 7(F7.2),/                               &
+              '      Number concentration: n_lognorm(nmod) = ', 7(ES12.4E3), ' (#/m3)' )
+19   FORMAT (/'      Size distribution read from a file.')
+20   FORMAT (/'   Nesting for salsa variables: ', L1 )
+21   FORMAT (/'   Emissions: salsa_emission_mode = ', A )
 
  END SUBROUTINE salsa_header
